Subject: [Fenics] Request for copyright consent forms

From: Anders Logg <[email-masked]>
Date: Tue, 1 Feb 2011 17:44:01 +0100

Dear contributors to the FEniCS Project,

As discussed earlier on the mailing list, we are going to collect
copyright consent forms for all material produced by the FEniCS
Project.

We do this for two reasons:

1. Relicensing of all software under the GNU LGPL v3 (or later).

2. As a protection against authors and/or employers that may want to
revoke code contributed to the FEniCS Project in the future.

What we need from you is to download the following two forms:

  Author consent form
  Institution consent form

from http://www.fenicsproject.org/pub/copyright/forms/

Then sign and send the forms (by regular mail) to

  Johannes Ring
  Simula Research Laboratory
  PO Box 134
  1325 Lysaker
  Norway

Johannes will administer the collection of the forms. Scanned copies
of all signed forms will be made available on the FEniCS web site.

Note that only one Institution consent form needs to be signed for
each institution (if there are multiple authors employed by the same
institution).

We would like to have the forms as soon as possible, preferrably
within 2 weeks (Feb 15) so that we have time to relicense all the
software for the upcoming release of FEniCS 1.0 (in March).

Direct any questions to me or to the mailing list.

--
Anders

---

From: Anders Logg <[email-masked]>
Date: Tue, 1 Feb 2011 18:28:43 +0100

Note that the Institution consent form has to be signed by the right
person in your organization, someone who has the right to sign such
forms on behalf of the organization. Usually, not even the head of
your department has this right, so make sure to investigate who has
the right to sign.

--
Anders

---

From: Johan Hake <[email-masked]>
Date: Wed, 9 Feb 2011 09:52:21 -0800

Hello!

UCSD is not willing to sign the consent statement about GPL 3... 

From the answer I got:
 
  LGPL incorporates GPL 3, and that is the problem. Earlier versions of the
  GPL did not deal in patent rights, while Version 3 does. It would commit a
  license to the entire UC patent estate, whether the inventors were an
  informed participant or not. I would need to consult further with UC General
  Counsel for a detailed answer, but the spirit is that the license
  overreaches in its commitments to patent rights beyond what the university
  is willing to do.

Are there any others that have got a similare answer?

Johan

---

From: Anders Logg <[email-masked]>
Date: Wed, 9 Feb 2011 19:10:04 +0100

>   overreaches in its commitments to patent rights beyond what the university

That seems strange. So UCSD will want to retain the right to sue users
of DOLFIN if you should happen to add code to DOLFIN that infringes on
some patent held by UCSD?

> Are there any others that have got a similare answer?

No problems so far. Here's what we have so far:

  http://www.fenicsproject.org/pub/copyright/authors/
  http://www.fenicsproject.org/pub/copyright/institutions/

--
Anders

---

From: Johan Hake <[email-masked]>
Date: Wed, 9 Feb 2011 10:14:51 -0800

On Wednesday February 9 2011 10:10:04 Anders Logg wrote:
> >   LGPL incorporates GPL 3, and that is the problem. Earlier versions of
> >   the GPL did not deal in patent rights, while Version 3 does. It would
> >   commit a license to the entire UC patent estate, whether the inventors
> >   were an informed participant or not. I would need to consult further
> >   with UC General Counsel for a detailed answer, but the spirit is that
> >   the license overreaches in its commitments to patent rights beyond
> >   what the university is willing to do.
> 

I have no clue what it means. But I will ask.

>   http://www.fenicsproject.org/pub/copyright/institutions/

I guess the Cambridge statement is not correct?

Johan

---

From: Johan Hake <[email-masked]>
Date: Wed, 9 Feb 2011 10:23:44 -0800

On Wednesday February 9 2011 10:14:51 Johan Hake wrote:
> > >   commit a license to the entire UC patent estate, whether the
> > >   inventors were an informed participant or not. I would need to
> > >   consult further with UC General Counsel for a detailed answer, but
> > >   the spirit is that the license overreaches in its commitments to
> > >   patent rights beyond what the university is willing to do.
> > 

Here is a more elaborated explaination:

  The language is pretty clear in section 11 of the GPL V3 license - it
  commits all the rights of the Licensor (the Regents of the University of
  California) to a license. Our normal licensing practice is to license one
  technology at a time, and we do not license the other patents along with it.
  Our guiding principles for licensing are at this link

  <http://invent.ucsd.edu/faculty/policies/guiding-principles.shtml>

Johan

> _______________________________________________
> Mailing list: https://launchpad.net/~fenics
> Post to     : [email-masked]
> Unsubscribe : https://launchpad.net/~fenics
> More help   : https://help.launchpad.net/ListHelp

---

From: Anders Logg <[email-masked]>
Date: Wed, 9 Feb 2011 19:37:46 +0100

>   <http://invent.ucsd.edu/faculty/policies/guiding-principles.shtml>

Is it this paragraph?

  "Each contributor grants you a non-exclusive, worldwide, royalty-free
  patent license under the contributor's essential patent claims, to
  make, use, sell, offer for sale, import and otherwise run, modify and
  propagate the contents of its contributor version."

Assuming that something in your contract makes UCSD the "contributor"
and not you personally, this means that UCSD grants any patent
licenses needed to run the code that you put into FEniCS.

The other option is to reserve the right to sue the users of FEniCS
for any UCSD patents that your code in FEnICS is infringing upon.

As far as I understand, it doesn't say anything about other patents
that UCSD have that are unrelated to the actual code in FEniCS.

If they refuse to sign the consent form, will they also refuse to let
you continue to contribute code to FEniCS? And sue us all for the code
you have contributed so far?

--
Anders

---

From: David Ham <[email-masked]>
Date: Wed, 9 Feb 2011 18:37:37 +0000

> I guess the Cambridge statement is not correct?

Cambridge are an odd case. Their IP rules specifically give copyright in 
most things to the individual staff who wrote them. That's the rule 
book. Basically it proves that Garth doesn't need a letter from Cambridge.

Regards,

David

-- 
Dr David Ham
Applied Modelling and Computation Group,
Department of Earth Science and Engineering,
Imperial College London,

http://www.imperial.ac.uk/people/david.ham

---

From: Johan Hake <[email-masked]>
Date: Wed, 9 Feb 2011 10:45:16 -0800

> book. Basically it proves that Garth doesn't need a letter from Cambridge.

Ok! I did not bother read the whole document ;)

Johan

---

From: "Garth N. Wells" <[email-masked]>
Date: Wed, 09 Feb 2011 18:47:32 +0000

> Ok! I did not bother read the whole document ;)

You should. It's a great read.

Garth

---

From: Anders Logg <[email-masked]>
Date: Wed, 9 Feb 2011 19:49:06 +0100

> You should. It's a great read.

:-)

--
Anders

---

From: Johan Hake <[email-masked]>
Date: Wed, 9 Feb 2011 11:02:32 -0800

> You should. It's a great read.

:) 

I bet you have!

Johan

---

From: Anders Logg <[email-masked]>
Date: Wed, 9 Feb 2011 20:17:27 +0100

> > You should. It's a great read.

If you ask, Garth can probably send you a version in Latin.

--
Anders

---

From: Johan Hake <[email-masked]>
Date: Wed, 9 Feb 2011 15:48:35 -0800

On Wednesday February 9 2011 15:37:38 Andy Ray Terrel wrote:
> On Wed, Feb 9, 2011 at 12:37 PM, Anders Logg <[email-masked]> wrote:
> >> > > >   LGPL incorporates GPL 3, and that is the problem. Earlier
> >> > > > versions of the GPL did not deal in patent rights, while Version
> >> > > > 3 does. It would commit a license to the entire UC patent estate,
> >> > > > whether the inventors were an informed participant or not. I
> >> > > > would need to consult further with UC General Counsel for a
> >> > > > detailed answer, but the spirit is that the license overreaches
> >> > > > in its commitments to patent rights beyond what the university is
> >> > > > willing to do.
> >> > > 
> >> > > That seems strange. So UCSD will want to retain the right to sue
> >> > > users of DOLFIN if you should happen to add code to DOLFIN that
> >> > > infringes on some patent held by UCSD?
> >> > 
> >>   commits all the rights of the Licensor (the Regents of the University
> >> of California) to a license. Our normal licensing practice is to
> >> license one technology at a time, and we do not license the other
> >> patents along with it. Our guiding principles for licensing are at this
> >> link
> >> 
> In the US, code and patentable "Intellectual Property" is usually
> considered property of the employer.  So the contributor has no right
> to give away the rights of a company's patents.  If they sign this
> form and Johan uploads something covered under another patent then it
> affects their rights to patent royalties.  So in effect they are
> saying they reserve the right to sue FEniCS (but probably Simula) if
> you encroach on their patents.
> 
> In practice, most open source code from US universities is distributed
> without regard to the law and for the most part everyone ignores it.
> For example, TTI-C should be the copyright holder on much of the code
> that you wrote in Chicago.

Does your university have the same policies? I guess I should just kept quite 
then...

Johan

> -- Andy

---

From: Johan Hake <[email-masked]>
Date: Wed, 9 Feb 2011 19:28:13 -0800

On Wednesday February 9 2011 18:23:51 Andy Ray Terrel wrote:
> On Wed, Feb 9, 2011 at 5:48 PM, Johan Hake <[email-masked]> wrote:
> >> >> > > > versions of the GPL did not deal in patent rights, while
> >> >> > > > Version 3 does. It would commit a license to the entire UC
> >> >> > > > patent estate, whether the inventors were an informed
> >> >> > > > participant or not. I would need to consult further with UC
> >> >> > > > General Counsel for a detailed answer, but the spirit is that
> >> >> > > > the license overreaches in its commitments to patent rights
> >> >> > > > beyond what the university is willing to do.
> >> >> > > 
> >> >>   The language is pretty clear in section 11 of the GPL V3 license -
> >> >> it commits all the rights of the Licensor (the Regents of the
> >> >> University of California) to a license. Our normal licensing
> >> >> practice is to license one technology at a time, and we do not
> >> >> license the other patents along with it. Our guiding principles for
> >> >> licensing are at this link
> >> >> 
> > Does your university have the same policies? I guess I should just kept
> > quite then...
> 
> I'm still waiting for word back from my department, but my
> contributions are so small that I don't think there could be any
> claims from my employer.

Would it be a point to collect what I have done during the stay here at UCSD, 
and hopefully show that there wont be anything to claim? Most of my work in 
FEniCS I did when I was at Simula.

Johan

---

From: Anders Logg <[email-masked]>
Date: Thu, 10 Feb 2011 09:07:06 +0100

> that you wrote in Chicago.

I haven't checked with TTI yet but expect it will be ok. We discussed
licensing and GPL when I was there and got the message that everything
was a-ok.

--
Anders

---

From: Johan Hake <[email-masked]>
Date: Mon, 14 Feb 2011 17:13:10 -0800

On Wednesday February 9 2011 19:37:10 Ridgway Scott wrote:
> I suspect this will be a general problem at all U.S. Universities.

Yeah, I pretty much have stalled here. Their final answer was:

  What the institution is being asked to sign is consent that the
  institution's IP be licensed under the LGPL V3. We do not consent to that,
  for the reasons I've been giving you. I don't know if I can make it any less
  complicated than that.

They did not answer my "what with the already contributed code" question 
either. But then I am not sure I want to know the answer. Maybe it is best to 
give up to get the consent from UCSD and let silence test the system?

Johan

> Ridg
> 
> On Feb 9, 2011, at 7:28 PM, Johan Hake wrote:
> >> On Wed, Feb 9, 2011 at 5:48 PM, Johan Hake <[email-masked]>
> >> 
> >> wrote:
> >>>> On Wed, Feb 9, 2011 at 12:37 PM, Anders Logg <[email-masked]>
> >>>> 
> >>>> wrote:
> >>>>>>  The language is pretty clear in section 11 of the GPL V3
> >>>>>> 
> >>>>>> license -
> >>>>>>  <http://invent.ucsd.edu/faculty/policies/guiding-principles.shtml
> >>>>>> 
> >>>>>> Johan
> >>>>> 
> >>>>> Is it this paragraph?
> >>>>>

---

From: David Ham <[email-masked]>
Date: Fri, 18 Feb 2011 16:00:16 +0000

There might be an escape from this. If UCSD's problem is with the patent 
clause in (L)GPL, you could instead ask if you might be allowed to 
provide code under the BSD licence. The BSD license has no patent clause 
so hopefully they will find it acceptable. It was also originally 
written by the University of California so presumably they're OK with it.

The point is that BSD is (L)GPL compatible so it is legally possible to 
incorporate BSD code in LGPL code and distribute the resulting code as 
LGPL. I think this fixes the problem.

Regards,

David

On 15/02/11 01:13, Johan Hake wrote:
>>>> On Wed, Feb 9, 2011 at 5:48 PM, Johan Hake<[email-masked]>
>>>>
>>>> wrote:
>>>>>> On Wed, Feb 9, 2011 at 12:37 PM, Anders Logg<[email-masked]>
>>>>>>
>>>>>> wrote:

---

From: Johan Hake <[email-masked]>
Date: Fri, 18 Feb 2011 08:16:18 -0800

Interesting!

I will check this out,

Johan

On Friday February 18 2011 08:00:16 David Ham wrote:
> >    institution's IP be licensed under the LGPL V3. We do not consent to
> >    that, for the reasons I've been giving you. I don't know if I can
> >    make it any less complicated than that.
> > 
> > either. But then I am not sure I want to know the answer. Maybe it is
> > best to give up to get the consent from UCSD and let silence test the
> > system?
> > 
> > Johan
> > 
> >> Ridg
> >>

---

From: Anders Logg <[email-masked]>
Date: Fri, 18 Feb 2011 19:47:31 +0100

Nice.

--
Anders

On Fri, Feb 18, 2011 at 04:00:16PM +0000, David Ham wrote:
> There might be an escape from this. If UCSD's problem is with the
> patent clause in (L)GPL, you could instead ask if you might be
> allowed to provide code under the BSD licence. The BSD license has
> no patent clause so hopefully they will find it acceptable. It was
> also originally written by the University of California so
> presumably they're OK with it.
>
> The point is that BSD is (L)GPL compatible so it is legally possible
> to incorporate BSD code in LGPL code and distribute the resulting
> code as LGPL. I think this fixes the problem.
>
> Regards,
>
> David
>